<html>
<body>
	<style type="text/css">
		html, body, #basicMap
		{
			width: 100%;
			height: 100%;
			margin: 0;
		}
	</style>
	<div id="Map"></div>
	<script src="http://www.openlayers.org/api/OpenLayers.js"></script>
	<script src="functions.js"></script>
	<script src="rel-map.js"></script>
	<script>
	        vectors = new OpenLayers.Layer.Vector("Vector Layer", {styleMap: myStyles});
        	map.addLayer(vectors);
<?
	$relid = number_format($_REQUEST['relid'], 0, '', '');
	$relxml = new SimpleXMLElement(file_get_contents('http:/'.'/www.fosm.org/api/0.6/relation/'.$relid.'/full'));

	$nodes = array();
	foreach($relxml->node as $node)
	{
		$id = (double)$node['id'];
		$lon = (float)$node['lon'];
		$lat = (float)$node['lat'];

		list($x, $y) = lonLatToMercator($lon, $lat);
		$nodes[$id]['x'] = $x;
		$nodes[$id]['y'] = $y;
	}

	$wktarr = array();
	foreach($relxml->relation as $rel)
	{
		foreach($rel->member as $mem)
		{
			if((string)$mem['type'] == 'relation')
				continue;

			if((string)$mem['type'] == 'way')
				$wktarr[] = parseWay((double)$mem['ref']);
		}
	}

	$features = '';
	foreach($wktarr as $key => $wkt)
	{
		echo "\t\tvar wkt$key = '$wkt';\n";
		echo "\t\tvar feature$key = new OpenLayers.Feature.Vector(OpenLayers.Geometry.fromWKT(wkt$key));\n";
		if($features != '')
			$features .= ',';
		$features .= 'feature'.$key;
	}

	echo "\t\tvectors.addFeatures([$features]);\n";
?>
//      	map.setCenter(lonLatToMercator(new OpenLayers.LonLat(151.2062, -33.85754)), 4);
        	map.zoomToExtent(vectors.getDataExtent());
	</script>
</body>
</html>
<?
        exit;

        function lonLatToMercator($lon, $lat)
        {
                $x = $lon * 20037508.34 / 180;
		$x -= 10;
                $lat = log(tan((90 + $lat) * pi() / 360)) / (pi() / 180);
                $y = $lat * 20037508.34 / 180;
		$y -= 3;

                return array($x, $y);
        }

	function parseWay($wayid)
	{
		global $relxml, $nodes;

		foreach($relxml->way as $way)
		{
			if((double)$way['id'] != $wayid)
				continue;

			$points = '';
			$firstref = 0;
			foreach($way->nd as $nd)
			{
				$ref = (double)$nd['ref'];
				if($nodes[$ref]['x'] == '' || $nodes[$ref]['y'] == '')
					continue;

				if($points != '')
					$points .= ', ';
				if($firstref == 0)
					$firstref = $ref;
				$points .= $nodes[$ref]['x'].' '.$nodes[$ref]['y'];
			}

			if($firstref == $ref)
				$points = 'POLYGON(('.$points.'))';
			else
				$points = 'LINESTRING('.$points.')';
			return $points;
		}

		return null;
	}
